module.exports = {
    rules: {
        // ---------------------------- 强制的风格 -----------------------------------
        // 允许使用console
        'no-console': [ 'off' ],
        // array函数必须返回值
        'array-callback-return': 'error',
        // 大括号规则：允许单行时省略大括号，但必须保持一致
        'curly': [ 'error', 'multi-line' ],
        // 点操作符和属性放在同一行
        'dot-location': [ 'error', 'property' ],
        // 禁用 caller 或 callee (no-caller)
        'no-caller': 'error',
        // 禁止使用看起来像除法的正则表达式
        'no-div-regex': 'error',
        // 禁止扩展原生对象
        'no-extend-native': 'error',
        // 禁止使用多行字符串
        'no-multi-str': 'error',
        // 禁止对原生对象赋值
        'no-native-reassign': 'error',
        // 禁用Function构造函数
        'no-new-func': 'error',
        // 禁止原始包装实例
        'no-new-wrappers': 'error',
        // 禁用八进制字面量
        'no-octal': 'error',
        // 禁止在字符串字面量中使用八进制转义序列
        'no-octal-escape': 'error',
        // 禁止重新声明变量
        'no-redeclare': 'error',
        // 禁止在 return 语句中使用赋值语句
        'no-return-assign': 'error',
        // 禁止自身比较
        'no-self-compare': 'error',
        // 不允许使用逗号操作符
        'no-sequences': 'error',
        // 限制可以被抛出的异常
        'no-throw-literal': 'error',
        // 禁用不必要的 .call() 和 .apply()
        'no-useless-call': 'error',
        // 禁止没有必要的字符拼接
        'no-useless-concat': 'error',
        // 禁止使用void操作符
        'no-void': 'error',
        // 禁用 with 语句
        'no-with': 'error',
        // 需要把立即执行的函数包裹起来，比如 (function () { return { y: 1 };})();
        'wrap-iife': [ 'error', 'inside' ],
        // 条件等于比较时，禁止字面量在左边，比如 if ('hello' === a)
        'yoda': [ 'error', 'never', { exceptRange: true }],
        // 禁用标签语句
        'no-labels': 'error',
        // 禁用不必要的分号
        'no-extra-semi': 'error',
        // 禁止使用 var
        // 'no-var': 'error',
        // 验证构造函数中 super() 的调用
        'constructor-super': 'error',
        // 不允许修改类声明的变量
        'no-class-assign': 'error',
        // 不允许改变用 const 声明的变量
        'no-const-assign': 'error',
        // 不允许类成员中有重复的名称
        'no-dupe-class-members': 'error',
        // 在构造函数中禁止在调用super()之前使用this或super
        'no-this-before-super': 'error',
        // 禁用 new Symbol()
        'no-new-symbol': 'error',
        // 要求调用无参构造函数时带括号
        'new-parens': 'error',
        // 禁止使用 Array 构造函数
        'no-array-constructor': 'error',
        // 禁止 if 语句作为唯一语句出现在 else 语句块中
        'no-lonely-if': 'error',
        // 禁止使用嵌套的三元表达式
        'no-nested-ternary': 'error',
        // 禁止使用 Object 构造函数
        'no-new-object': 'error',
        // 禁止使用一元操作符 ++ 和 --
        'no-plusplus': [ 'warn', { allowForLoopAfterthoughts: true }],
        // 要求在变量声明周围换行
        'one-var-declaration-per-line': [ 'error', 'initializations' ],
        // 禁止使用 Unicode 字节顺序标记 (BOM)
        'unicode-bom': 'error',
        // 禁止不必要的布尔类型转换
        'no-extra-boolean-cast': 'error',
        // 要求使用 === 和 !==
        // 'eqeqeq': [ 'error', 'allow-null' ],
        // 禁止在 else 前有 return
        'no-else-return': 'error',
        // 关键字不能被遮蔽
        'no-shadow-restricted-names': 'error',
        // 禁止在嵌套的块中出现变量声明或 function 声明
        'no-inner-declarations': 'error',
        // 禁止对 function 声明重新赋值
        'no-func-assign': 'error',

    }
};